<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>library_dir_dir/include/rdc_start_.incl.pl1</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="pl1">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.PreProc { color: #00afaf; }
.LineNr { color: #585858; }
.Operator { color: #5fafd7; }
.Keyword { color: #00afaf; }
.Macro { color: #00afaf; }
.pliRainbow_lv1_p0 { color: #ffffe0; }
.Normal { color: #d0d0d0; background-color: #000000; padding-bottom: 1px; }
.Number { color: #ff5faf; }
.Boolean { color: #d7af00; font-weight: bold; }
.Function { color: #d0d0d0; }
.StorageClass { color: #d7875f; font-weight: bold; }
.pliRainbow_lv0_o0 { color: #add8e6; }
.pliRainbow_lv0_p0 { color: #add8e6; }
.Comment { color: #808080; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>          <span class="Comment">/* START OF:        rdc_start_.incl.pl1             *  *  *  *  *  *  */</span>
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L4" class="LineNr">  4 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L5" class="LineNr">  5 </span>          <span class="Comment">/* N^H__^Ha_^Hm_^He:  rdc_start_.incl.pl1                                                 */</span>
<span id="L6" class="LineNr">  6 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L7" class="LineNr">  7 </span>          <span class="Comment">/*      This include segment is used by compilers generated by the    */</span>
<span id="L8" class="LineNr">  8 </span>          <span class="Comment">/* reduction_compiler.  Such compilers include a SEMANTIC_ANALYSIS    */</span>
<span id="L9" class="LineNr">  9 </span>          <span class="Comment">/* subroutine generated by the reduction_compiler.  This subroutine   */</span>
<span id="L10" class="LineNr"> 10 </span>          <span class="Comment">/* compares a chain of input tokens with token requirements           */</span>
<span id="L11" class="LineNr"> 11 </span>          <span class="Comment">/* specified in reductions.  This include segment declares the        */</span>
<span id="L12" class="LineNr"> 12 </span>          <span class="Comment">/* structure of the input tokens (which are generated by lex_string_),*/</span>
<span id="L13" class="LineNr"> 13 </span>          <span class="Comment">/* defines the beginning of the SEMANTIC_ANALYSIS procedure, and      */</span>
<span id="L14" class="LineNr"> 14 </span>          <span class="Comment">/* declares Pthis_token, a global pointer variable which points to    */</span>
<span id="L15" class="LineNr"> 15 </span>          <span class="Comment">/* the &quot;current&quot; token being referenced by SEMANTIC_ANALYSIS.         */</span>
<span id="L16" class="LineNr"> 16 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L17" class="LineNr"> 17 </span>          <span class="Comment">/* S^H__^Ht_^Ha_^Ht_^Hu_^Hs                                                               */</span>
<span id="L18" class="LineNr"> 18 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L19" class="LineNr"> 19 </span>          <span class="Comment">/* 0) Created:  April, 1974 by G. C. Dixon                            */</span>
<span id="L20" class="LineNr"> 20 </span>          <span class="Comment">/*                                                                    */</span>
<span id="L21" class="LineNr"> 21 </span>          <span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>     <span class="Keyword">dcl</span>  <span class="Normal">Pthis_token</span>                   <span class="Macro">ptr</span><span class="Normal">;</span>                <span class="Comment">/* ptr to the &quot;current&quot; token being acted upon.   */</span>
<span id="L24" class="LineNr"> 24 </span>^L
<span id="L25" class="LineNr"> 25 </span><span class="PreProc">%</span><span class="PreProc">include</span> <span class="Normal">lex_descriptors_</span><span class="Normal">;</span>
<span id="L26" class="LineNr"> 26 </span>^L
<span id="L27" class="LineNr"> 27 </span><span class="Comment">/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  **  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */</span>
<span id="L28" class="LineNr"> 28 </span>
<span id="L29" class="LineNr"> 29 </span>
<span id="L30" class="LineNr"> 30 </span><span class="Normal">SEMANTIC_ANALYSIS</span><span class="Operator">:</span>  <span class="Keyword">procedure</span><span class="Normal">;</span>                              <span class="Comment">/* procedure which analyzes the syntax and        */</span>
<span id="L31" class="LineNr"> 31 </span>                                                            <span class="Comment">/* semantics of the tokens in the input list.     */</span>
<span id="L32" class="LineNr"> 32 </span>
<span id="L33" class="LineNr"> 33 </span>     <span class="Keyword">dcl</span>                                                    <span class="Comment">/*        automatic variables                     */</span>
<span id="L34" class="LineNr"> 34 </span>          <span class="Normal">LTOKEN_REQD_VALUE</span>             <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">18</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">,</span>      <span class="Comment">/* length of a token requirement.                 */</span>
<span id="L35" class="LineNr"> 35 </span>          <span class="Normal">NRED</span>                          <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>          <span class="Comment">/* number of the reduction tokens are being       */</span>
<span id="L36" class="LineNr"> 36 </span>                                                            <span class="Comment">/* compared to.                                   */</span>
<span id="L37" class="LineNr"> 37 </span>          <span class="Normal">PRED</span>                          <span class="Macro">ptr</span><span class="Normal">,</span>                <span class="Comment">/* ptr to the reduction tokens are being          */</span>
<span id="L38" class="LineNr"> 38 </span>                                                            <span class="Comment">/* compared to.                                   */</span>
<span id="L39" class="LineNr"> 39 </span>          <span class="Normal">PTOKEN_REQD</span>                   <span class="Macro">ptr</span><span class="Normal">,</span>                <span class="Comment">/* ptr to token requirement descriptor associated */</span>
<span id="L40" class="LineNr"> 40 </span>                                                            <span class="Comment">/* with reduction tokens are being compared to.   */</span>
<span id="L41" class="LineNr"> 41 </span>          <span class="Normal">PTOKEN_REQD_VALUE</span>             <span class="Macro">ptr</span><span class="Normal">,</span>                <span class="Comment">/* ptr to a token requirement.                    */</span>
<span id="L42" class="LineNr"> 42 </span>          <span class="Normal">STOKEN_FCN</span>                    <span class="Macro">bit</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">1</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">aligned</span><span class="Normal">,</span>     <span class="Comment">/* return value from a relative syntax function.  */</span>
<span id="L43" class="LineNr"> 43 </span>          <span class="Normal">CODE</span>                          <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">35</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">,</span>      <span class="Comment">/* an error code.                                 */</span>
<span id="L44" class="LineNr"> 44 </span>          <span class="Normal">I</span>                             <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="Normal">,</span>          <span class="Comment">/* a do-group index.                              */</span>
<span id="L45" class="LineNr"> 45 </span>          <span class="StorageClass">NUMBER</span>                        <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">35</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>      <span class="Comment">/* fixed binary representation of a decimal       */</span>
<span id="L46" class="LineNr"> 46 </span>                                                            <span class="Comment">/* number character string.                       */</span>
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>     <span class="Keyword">dcl</span>                                                    <span class="Comment">/*        based variables                         */</span>
<span id="L49" class="LineNr"> 49 </span>          <span class="Number">1</span> <span class="Macro">RED</span>                         <span class="Macro">aligned</span> <span class="Macro">based</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">PRED</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">,</span>
<span id="L50" class="LineNr"> 50 </span>                                                            <span class="Comment">/* descriptor for reduction tokens are being      */</span>
<span id="L51" class="LineNr"> 51 </span>                                                            <span class="Comment">/* compared to.                                   */</span>
<span id="L52" class="LineNr"> 52 </span>            <span class="Number">2</span> <span class="Normal">TOKEN_REQD</span>                <span class="Macro">unaligned</span><span class="Normal">,</span>
<span id="L53" class="LineNr"> 53 </span>              <span class="Number">3</span> <span class="Normal">IFIRST</span>                  <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">17</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">unal</span><span class="Normal">,</span> <span class="Comment">/* index of first token requirement.              */</span>
<span id="L54" class="LineNr"> 54 </span>              <span class="Number">3</span> <span class="Normal">ILAST</span>                   <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">17</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">unal</span><span class="Normal">,</span> <span class="Comment">/* index of last  token requirement associated    */</span>
<span id="L55" class="LineNr"> 55 </span>                                                            <span class="Comment">/* with this reduction.                           */</span>
<span id="L56" class="LineNr"> 56 </span>          <span class="Number">1</span> <span class="Normal">TOKEN_REQD</span>                  <span class="Macro">aligned</span> <span class="Macro">based</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">PTOKEN_REQD</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">,</span>
<span id="L57" class="LineNr"> 57 </span>                                                            <span class="Comment">/* a token requirement descriptor.                */</span>
<span id="L58" class="LineNr"> 58 </span>            <span class="Number">2</span> <span class="Normal">FORM</span>                      <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">17</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">unal</span><span class="Normal">,</span> <span class="Comment">/* form of the token requirement:                 */</span>
<span id="L59" class="LineNr"> 59 </span>                                                            <span class="Comment">/*  -1 = relative token requirement function;     */</span>
<span id="L60" class="LineNr"> 60 </span>                                                            <span class="Comment">/*       TYPE = index of the particular token     */</span>
<span id="L61" class="LineNr"> 61 </span>                                                            <span class="Comment">/*              function in the token_fcn array.  */</span>
<span id="L62" class="LineNr"> 62 </span>                                                            <span class="Comment">/*   0 = built-in token requirement function;     */</span>
<span id="L63" class="LineNr"> 63 </span>                                                            <span class="Comment">/*       TYPE = as defined below.                 */</span>
<span id="L64" class="LineNr"> 64 </span>                                                            <span class="Comment">/*  &gt;0 = absolute token requirement:              */</span>
<span id="L65" class="LineNr"> 65 </span>                                                            <span class="Comment">/*       FORM = index(TOKEN_STRINGS,TOKEN_REQD);  */</span>
<span id="L66" class="LineNr"> 66 </span>                                                            <span class="Comment">/*       TYPE = length(TOKEN_REQD);               */</span>
<span id="L67" class="LineNr"> 67 </span>            <span class="Number">2</span> <span class="Normal">TYPE</span>                      <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">17</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">unal</span><span class="Normal">,</span> <span class="Comment">/* TYPE of built-in token requirement function:   */</span>
<span id="L68" class="LineNr"> 68 </span>                                                            <span class="Comment">/*   1 = compile test to see if input token       */</span>
<span id="L69" class="LineNr"> 69 </span>                                                            <span class="Comment">/*       chain is exhausted (&lt;no-token&gt;).         */</span>
<span id="L70" class="LineNr"> 70 </span>                                                            <span class="Comment">/*   2 = compile test for any token value         */</span>
<span id="L71" class="LineNr"> 71 </span>                                                            <span class="Comment">/*       (&lt;any-token&gt;).                           */</span>
<span id="L72" class="LineNr"> 72 </span>                                                            <span class="Comment">/*   3 = compile test for a PL/I identifier       */</span>
<span id="L73" class="LineNr"> 73 </span>                                                            <span class="Comment">/*       (&lt;name&gt;) of 32 or fewer characters.      */</span>
<span id="L74" class="LineNr"> 74 </span>                                                            <span class="Comment">/*   4 = compile test for token which is a        */</span>
<span id="L75" class="LineNr"> 75 </span>                                                            <span class="Comment">/*       &lt;decimal-integer&gt;.                       */</span>
<span id="L76" class="LineNr"> 76 </span>                                                            <span class="Comment">/*   5 = compile test for token which is a single */</span>
<span id="L77" class="LineNr"> 77 </span>                                                            <span class="Comment">/*       backspace character (&lt;BS&gt;).              */</span>
<span id="L78" class="LineNr"> 78 </span>                                                            <span class="Comment">/*   6 = compile test for a token which is a      */</span>
<span id="L79" class="LineNr"> 79 </span>                                                            <span class="Comment">/*       &lt;quoted-string&gt;.                         */</span>
<span id="L80" class="LineNr"> 80 </span>^L
<span id="L81" class="LineNr"> 81 </span>          <span class="Number">1</span> <span class="Normal">TOKEN_REQD_STRING</span>           <span class="Macro">aligned</span> <span class="Macro">based</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">PTOKEN_REQD</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">,</span>
<span id="L82" class="LineNr"> 82 </span>                                                            <span class="Comment">/* overlay for an absolute token requirement      */</span>
<span id="L83" class="LineNr"> 83 </span>                                                            <span class="Comment">/* descriptor.                                    */</span>
<span id="L84" class="LineNr"> 84 </span>            <span class="Number">2</span> <span class="Normal">I</span>                         <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">17</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">unal</span><span class="Normal">,</span> <span class="Comment">/* index into list of token strings of the        */</span>
<span id="L85" class="LineNr"> 85 </span>                                                            <span class="Comment">/* absolute token string assoc w/ descriptor.     */</span>
<span id="L86" class="LineNr"> 86 </span>            <span class="Number">2</span> <span class="Normal">L</span>                         <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">17</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">unal</span><span class="Normal">,</span> <span class="Comment">/* length of the absolute token string.           */</span>
<span id="L87" class="LineNr"> 87 </span>          <span class="Normal">TOKEN_REQD_VALUE</span>              <span class="StorageClass">char</span><span class="pliRainbow_lv0_p0">(</span><span class="Normal">LTOKEN_REQD_VALUE</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">based</span> <span class="pliRainbow_lv0_p0">(</span><span class="Normal">PTOKEN_REQD_VALUE</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L88" class="LineNr"> 88 </span>                                                            <span class="Comment">/* absolute token string which token is reqd      */</span>
<span id="L89" class="LineNr"> 89 </span>                                                            <span class="Comment">/* to match in order for tokens which are         */</span>
<span id="L90" class="LineNr"> 90 </span>                                                            <span class="Comment">/* &quot;current&quot; on the list to match the reduction.  */</span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>     <span class="Keyword">dcl</span>                                                    <span class="Comment">/*        builtin functions                       */</span>
<span id="L93" class="LineNr"> 93 </span>         <span class="pliRainbow_lv0_p0">(</span><span class="Function">addr</span><span class="pliRainbow_lv0_o0">,</span> <span class="Function">max</span><span class="pliRainbow_lv0_o0">,</span> <span class="Boolean">null</span><span class="pliRainbow_lv0_o0">,</span> <span class="Function">search</span><span class="pliRainbow_lv0_o0">,</span> <span class="Function">substr</span><span class="pliRainbow_lv0_o0">,</span> <span class="Function">verify</span><span class="pliRainbow_lv0_p0">)</span>
<span id="L94" class="LineNr"> 94 </span>                                        <span class="Macro">builtin</span><span class="Normal">;</span>
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>     <span class="Keyword">dcl</span>                                                    <span class="Comment">/*        entries                                 */</span>
<span id="L97" class="LineNr"> 97 </span>          <span class="Normal">cv_dec_check_</span>                 <span class="Keyword">entry</span> <span class="pliRainbow_lv0_p0">(</span><span class="StorageClass">char</span><span class="pliRainbow_lv1_p0">(</span><span class="Operator">*</span><span class="pliRainbow_lv1_p0">)</span><span class="pliRainbow_lv0_o0">,</span> <span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv1_p0">(</span><span class="Number">35</span><span class="pliRainbow_lv1_p0">)</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">returns</span> <span class="pliRainbow_lv0_p0">(</span><span class="Macro">fixed</span> <span class="Macro">bin</span><span class="pliRainbow_lv1_p0">(</span><span class="Number">35</span><span class="pliRainbow_lv1_p0">)</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>     <span class="Keyword">dcl</span>                                                    <span class="Comment">/*        static variables                        */</span>
<span id="L100" class="LineNr">100 </span>          <span class="Normal">BACKSPACE</span>                     <span class="StorageClass">char</span><span class="pliRainbow_lv0_p0">(</span><span class="Number">1</span><span class="pliRainbow_lv0_p0">)</span> <span class="Macro">aligned</span> <span class="StorageClass">int</span> <span class="Macro">static</span> <span class="Macro">init</span> <span class="pliRainbow_lv0_p0">(</span><span class="Operator">&quot;</span>^H<span class="Operator">&quot;</span><span class="pliRainbow_lv0_p0">)</span><span class="Normal">;</span>
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>          <span class="Comment">/* END OF:          rdc_start_.incl.pl1             *  *  *  *  *  *  */</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
